function [A,Y] = hermiteo(fun,xi,krotnosci,parametr)
% "Uogolniona" interpolacja Hermite'a.
% Wektor krotnosci - wektor rzedow pochodnych zgodnych w wezlach np [1 0 2 0]
if(max(-krotnosci) > 0), 'Blad: ujemna krotnosc', return; end,
n=length(xi);        % liczba wezlow
if(n ~= length(krotnosci)), 'Blad: liczba wezlow != liczba krotnosci', return;, end,
m=sum(krotnosci)+n;  % liczba rownan i niewiadomych = stopien wielom.interpol.-1
if(nargin==3) funkcja=[fun,'(x,r)'];
else          funkcja=[fun,'(x,r,parametr)'];
end,
% tworzenie macierzy "Vandermonde'a"
A=zeros(n,m); Y=zeros(m,1);
[lw,lk]=size(xi); if(lw>lk) w=xi; else w=xi'; end,
x=w; r=0; Y(1:n)=eval(funkcja);
A(:,m)=ones(n,1); for i=m-1:-1:1, A(:,i)=A(:,i+1).*w; end,
mk=max(krotnosci);
if(mk > 0)
  w=n; 
  A(n+1:m,:)=zeros(m-n,m);
  for i=1:n,
    if(krotnosci(i) > 0)
      for j=1:krotnosci(i),
        w=w+1; x=xi(i); r=j; Y(w)=eval(funkcja); x=1;
        for k=j:m-1,
          A(w,m-k)=gamma(k+1)/gamma(k-j+1)*x; x=x*xi(i); 
        end,  
      end,
    end,
  end,
end,
wsp=(A\Y).';
x=linspace(-max(-xi),max(xi),500); r=0; y=eval(funkcja);
yh=polyval(wsp,x);
plot(x,y-yh); grid,