function [l,h] = lagrherm(fun,diff,a,b,n)
% porownanie interpolacji Lagrange'a i Hermite'a
% w przedziale [a, b] - n+1 wezlow Hermite'a, - 2n+2 wezlow Lagrange'a
nl=2*n+2; nh=n+1; hh=(b-a)/n; hl=(b-a)/(2*n+1);
xl=[]; yl=[];
for j=1:2*n+2, xl(j)=a+(j-1)*hl; yl(j)=feval(fun,xl(j)); end,
xl = xl(:); yl = yl(:);
A = zeros(nl,nl);
for j=1:nl  A(:,j) = xl.^(nl-j);  end
l = (A\yl).';
xh=[]; yh=[];
for j=1:n+1,
  xh(j)=a+(j-1)*hh;  yh(j)=feval(fun,xh(j));  yh(n+1+j)=feval(diff,xh(j));
end,
xh = xh(:); yh = yh(:);
A = zeros(2*nh,2*nh);
for j=1:2*nh-1,  A(:,j) = [xh.^(2*nh-j); (2*nh-j)*xh.^(2*nh-j-1)];  end,
A(:,2*nh) = [ones(nh,1); zeros(nh,1)];
h = (A\yh).';
x=a:(b-a)/500:b;
plot(x,feval(fun,x),x,polyval(l,x),x,polyval(h,x),xl,yl,'wo',xh,yh(1:nh),'wx'),
pause,
plot(x,feval(fun,x)-polyval(l,x),'g',x,feval(fun,x)-polyval(h,x),'b'),

